Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/InteractiveSymbolicDataAnalysisSolutionSimplifierView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/InteractiveSymbolicDataAnalysisSolutionSimplifierView.Designer.cs	(revision 8945)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/InteractiveSymbolicDataAnalysisSolutionSimplifierView.Designer.cs	(revision 8946)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -45,5 +45,5 @@
     /// </summary>
     private void InitializeComponent() {
-      this.treeChart = new HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views.SymbolicExpressionTreeChart();
+      this.components = new System.ComponentModel.Container();
       this.viewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
       this.splitContainer = new System.Windows.Forms.SplitContainer();
@@ -52,4 +52,5 @@
       this.btnSimplify = new System.Windows.Forms.Button();
       this.btnOptimizeConstants = new System.Windows.Forms.Button();
+      this.treeChart = new HeuristicLab.Problems.DataAnalysis.Symbolic.Views.InteractiveSymbolicExpressionTreeChart();
       this.grpViewHost = new System.Windows.Forms.GroupBox();
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).BeginInit();
@@ -61,20 +62,4 @@
       this.grpViewHost.SuspendLayout();
       this.SuspendLayout();
-      // 
-      // treeChart
-      // 
-      this.treeChart.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-            | System.Windows.Forms.AnchorStyles.Left)
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.treeChart.BackgroundColor = System.Drawing.Color.White;
-      this.treeChart.LineColor = System.Drawing.Color.Black;
-      this.treeChart.Location = new System.Drawing.Point(6, 16);
-      this.treeChart.Name = "treeChart";
-      this.treeChart.Size = new System.Drawing.Size(201, 291);
-      this.treeChart.Spacing = 5;
-      this.treeChart.TabIndex = 0;
-      this.treeChart.TextFont = new System.Drawing.Font("Times New Roman", 8F);
-      this.treeChart.Tree = null;
-      this.treeChart.SymbolicExpressionTreeNodeDoubleClicked += new System.Windows.Forms.MouseEventHandler(this.treeChart_SymbolicExpressionTreeNodeDoubleClicked);
       // 
       // viewHost
@@ -113,4 +98,5 @@
       // grpSimplify
       // 
+      this.grpSimplify.AutoSize = true;
       this.grpSimplify.Controls.Add(this.flowLayoutPanel);
       this.grpSimplify.Controls.Add(this.treeChart);
@@ -157,4 +143,23 @@
       this.btnOptimizeConstants.Click += new System.EventHandler(this.btnOptimizeConstants_Click);
       // 
+      // treeChart
+      // 
+      this.treeChart.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.treeChart.BackgroundColor = System.Drawing.Color.White;
+      this.treeChart.LineColor = System.Drawing.Color.Black;
+      this.treeChart.Location = new System.Drawing.Point(6, 16);
+      this.treeChart.Name = "treeChart";
+      this.treeChart.Size = new System.Drawing.Size(201, 291);
+      this.treeChart.Spacing = 5;
+      this.treeChart.SuspendRepaint = false;
+      this.treeChart.TabIndex = 0;
+      this.treeChart.TextFont = new System.Drawing.Font("Times New Roman", 8F);
+      this.treeChart.Tree = null;
+      this.treeChart.SymbolicExpressionTreeChanged += new System.EventHandler(this.treeChart_SymbolicExpressionTreeChanged);
+      this.treeChart.SymbolicExpressionTreeNodeChanged += new System.EventHandler(this.treeChart_SymbolicExpressionTreeNodeChanged);
+      this.treeChart.SymbolicExpressionTreeNodeDoubleClicked += new System.Windows.Forms.MouseEventHandler(this.treeChart_SymbolicExpressionTreeNodeDoubleClicked);
+      // 
       // grpViewHost
       // 
@@ -171,9 +176,11 @@
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
       this.Controls.Add(this.splitContainer);
+      this.DoubleBuffered = true;
       this.Name = "InteractiveSymbolicDataAnalysisSolutionSimplifierView";
       this.Size = new System.Drawing.Size(564, 348);
       this.splitContainer.Panel1.ResumeLayout(false);
+      this.splitContainer.Panel1.PerformLayout();
       this.splitContainer.Panel2.ResumeLayout(false);
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).EndInit();
@@ -188,5 +195,5 @@
     #endregion
 
-    private HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views.SymbolicExpressionTreeChart treeChart;
+    private InteractiveSymbolicExpressionTreeChart treeChart;
     private System.Windows.Forms.SplitContainer splitContainer;
     private HeuristicLab.MainForm.WindowsForms.ViewHost viewHost;
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/InteractiveSymbolicDataAnalysisSolutionSimplifierView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/InteractiveSymbolicDataAnalysisSolutionSimplifierView.cs	(revision 8945)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/InteractiveSymbolicDataAnalysisSolutionSimplifierView.cs	(revision 8946)
@@ -34,10 +34,14 @@
     private Dictionary<ISymbolicExpressionTreeNode, ISymbolicExpressionTreeNode> replacementNodes;
     private Dictionary<ISymbolicExpressionTreeNode, double> nodeImpacts;
-    private bool updateInProgress = false;
+    private Dictionary<ISymbolicExpressionTreeNode, double> originalValues;
+    private Dictionary<ISymbolicExpressionTreeNode, string> originalVariableNames;
 
     public InteractiveSymbolicDataAnalysisSolutionSimplifierView() {
       InitializeComponent();
-      this.replacementNodes = new Dictionary<ISymbolicExpressionTreeNode, ISymbolicExpressionTreeNode>();
-      this.nodeImpacts = new Dictionary<ISymbolicExpressionTreeNode, double>();
+      replacementNodes = new Dictionary<ISymbolicExpressionTreeNode, ISymbolicExpressionTreeNode>();
+      nodeImpacts = new Dictionary<ISymbolicExpressionTreeNode, double>();
+      originalValues = new Dictionary<ISymbolicExpressionTreeNode, double>();
+      originalVariableNames = new Dictionary<ISymbolicExpressionTreeNode, string>();
+
       this.Caption = "Interactive Solution Simplifier";
     }
@@ -50,65 +54,37 @@
     protected override void RegisterContentEvents() {
       base.RegisterContentEvents();
-      Content.ModelChanged += new EventHandler(Content_ModelChanged);
-      Content.ProblemDataChanged += new EventHandler(Content_ProblemDataChanged);
+      Content.ModelChanged += Content_Changed;
+      Content.ProblemDataChanged += Content_Changed;
     }
     protected override void DeregisterContentEvents() {
       base.DeregisterContentEvents();
-      Content.ModelChanged -= new EventHandler(Content_ModelChanged);
-      Content.ProblemDataChanged -= new EventHandler(Content_ProblemDataChanged);
-    }
-
-    private void Content_ModelChanged(object sender, EventArgs e) {
-      OnModelChanged();
-    }
-    private void Content_ProblemDataChanged(object sender, EventArgs e) {
-      OnProblemDataChanged();
-    }
-
-    protected virtual void OnModelChanged() {
-      this.CalculateReplacementNodesAndNodeImpacts();
-    }
-
-    protected virtual void OnProblemDataChanged() {
-      this.CalculateReplacementNodesAndNodeImpacts();
+      Content.ModelChanged -= Content_Changed;
+      Content.ProblemDataChanged -= Content_Changed;
+    }
+
+    private void Content_Changed(object sender, EventArgs e) {
+      UpdateView();
     }
 
     protected override void OnContentChanged() {
       base.OnContentChanged();
-      this.CalculateReplacementNodesAndNodeImpacts();
-      this.viewHost.Content = this.Content;
-    }
-
-    private void CalculateReplacementNodesAndNodeImpacts() {
-      if (Content != null && Content.Model != null && Content.ProblemData != null) {
-        var tree = Content.Model.SymbolicExpressionTree;
-        var replacementValues = CalculateReplacementValues(tree);
-        foreach (var pair in replacementValues) {
-          if (!(pair.Key is ConstantTreeNode)) {
-            replacementNodes[pair.Key] = MakeConstantTreeNode(pair.Value);
-          }
-        }
-        nodeImpacts = CalculateImpactValues(Content.Model.SymbolicExpressionTree);
-
-        if (!updateInProgress) {
-          // automatically fold all branches with impact = 1
-          List<ISymbolicExpressionTreeNode> nodeList = Content.Model.SymbolicExpressionTree.Root.GetSubtree(0).IterateNodesPrefix().ToList();
-          foreach (var parent in nodeList) {
-            for (int subTreeIndex = 0; subTreeIndex < parent.SubtreeCount; subTreeIndex++) {
-              var child = parent.GetSubtree(subTreeIndex);
-              if (!(child.Symbol is Constant) && nodeImpacts[child].IsAlmost(0.0)) {
-                SwitchNodeWithReplacementNode(parent, subTreeIndex);
-              }
-            }
-          }
-        }
-
-        // show only interesting part of solution 
-        if (tree.Root.SubtreeCount > 1)
-          this.treeChart.Tree = new SymbolicExpressionTree(tree.Root); // RPB + ADFs
-        else
-          this.treeChart.Tree = new SymbolicExpressionTree(tree.Root.GetSubtree(0).GetSubtree(0)); // 1st child of RPB
-        this.PaintNodeImpacts();
-      }
+      UpdateView();
+      viewHost.Content = this.Content;
+    }
+
+    private void UpdateView() {
+      if (Content == null || Content.Model == null || Content.ProblemData == null) return;
+      var tree = Content.Model.SymbolicExpressionTree;
+
+      var replacementValues = CalculateReplacementValues(tree);
+      foreach (var pair in replacementValues.Where(pair => !(pair.Key is ConstantTreeNode))) {
+        replacementNodes[pair.Key] = MakeConstantTreeNode(pair.Value);
+      }
+
+      nodeImpacts = CalculateImpactValues(tree);
+
+      var model = Content.Model.SymbolicExpressionTree;
+      treeChart.Tree = model.Root.SubtreeCount > 1 ? new SymbolicExpressionTree(model.Root) : new SymbolicExpressionTree(model.Root.GetSubtree(0).GetSubtree(0));
+      PaintNodeImpacts();
     }
 
@@ -117,9 +93,7 @@
     protected abstract void UpdateModel(ISymbolicExpressionTree tree);
 
-    private ConstantTreeNode MakeConstantTreeNode(double value) {
-      Constant constant = new Constant();
-      constant.MinValue = value - 1;
-      constant.MaxValue = value + 1;
-      ConstantTreeNode constantTreeNode = (ConstantTreeNode)constant.CreateTreeNode();
+    private static ConstantTreeNode MakeConstantTreeNode(double value) {
+      var constant = new Constant { MinValue = value - 1, MaxValue = value + 1 };
+      var constantTreeNode = (ConstantTreeNode)constant.CreateTreeNode();
       constantTreeNode.Value = value;
       return constantTreeNode;
@@ -127,25 +101,84 @@
 
     private void treeChart_SymbolicExpressionTreeNodeDoubleClicked(object sender, MouseEventArgs e) {
-      VisualSymbolicExpressionTreeNode visualTreeNode = (VisualSymbolicExpressionTreeNode)sender;
+      if (!treeChart.TreeValid) return;
+      var visualNode = (VisualSymbolicExpressionTreeNode)sender;
+      var symbExprTreeNode = (SymbolicExpressionTreeNode)visualNode.SymbolicExpressionTreeNode;
+      if (symbExprTreeNode == null) return;
       var tree = Content.Model.SymbolicExpressionTree;
-      foreach (SymbolicExpressionTreeNode treeNode in tree.IterateNodesPostfix()) {
-        for (int i = 0; i < treeNode.SubtreeCount; i++) {
-          ISymbolicExpressionTreeNode subTree = treeNode.GetSubtree(i);
-          // only allow to replace nodes for which a replacement value is known (replacement value for ADF nodes are not available)
-          if (subTree == visualTreeNode.SymbolicExpressionTreeNode && replacementNodes.ContainsKey(subTree)) {
-            SwitchNodeWithReplacementNode(treeNode, i);
-
-            // show only interesting part of solution 
-            if (tree.Root.SubtreeCount > 1)
-              this.treeChart.Tree = new SymbolicExpressionTree(tree.Root); // RPB + ADFs
-            else
-              this.treeChart.Tree = new SymbolicExpressionTree(tree.Root.GetSubtree(0).GetSubtree(0)); // 1st child of RPB
-
-            updateInProgress = true;
-            UpdateModel(tree);
-            updateInProgress = false;
-            return; // break all loops
+
+      bool update = false;
+      // check if the node value/weight has been altered
+      // if so, the first double click will return the node to its original value/weight/variable name
+      // the next double click will replace the ConstantNode with the original SymbolicExpressionTreeNode
+      if (originalVariableNames.ContainsKey(symbExprTreeNode)) {
+        var variable = (VariableTreeNode)symbExprTreeNode;
+        variable.VariableName = originalVariableNames[symbExprTreeNode];
+        originalVariableNames.Remove(variable);
+        update = true;
+      } else if (originalValues.ContainsKey(symbExprTreeNode)) {
+        double value = originalValues[symbExprTreeNode];
+        if (symbExprTreeNode.Symbol is Constant) {
+          var constantTreeNode = (ConstantTreeNode)symbExprTreeNode;
+          constantTreeNode.Value = value;
+        } else if (symbExprTreeNode.Symbol is Variable) {
+          var variable = (VariableTreeNode)symbExprTreeNode;
+          variable.Weight = value;
+        }
+        originalValues.Remove(symbExprTreeNode);
+        update = true;
+      } else if (replacementNodes.ContainsKey(symbExprTreeNode)) {
+        foreach (var treeNode in tree.IterateNodesPostfix()) {
+          for (int i = 0; i < treeNode.SubtreeCount; i++) {
+            var subtree = treeNode.GetSubtree(i);
+            if (subtree == symbExprTreeNode) {
+              SwitchNodeWithReplacementNode(treeNode, i);
+              // show only interesting part of solution 
+              treeChart.Tree = tree.Root.SubtreeCount > 1
+                                 ? new SymbolicExpressionTree(tree.Root)
+                                 : new SymbolicExpressionTree(tree.Root.GetSubtree(0).GetSubtree(0));
+              update = true;
+            }
           }
-        }
+          if (update) break;
+        }
+      }
+      if (update) UpdateModel(tree);
+    }
+
+    private void treeChart_SymbolicExpressionTreeChanged(object sender, EventArgs e) {
+      UpdateModel(Content.Model.SymbolicExpressionTree);
+      UpdateView();
+    }
+
+    private void treeChart_SymbolicExpressionTreeNodeChanged(object sender, EventArgs e) {
+      var dialog = (ValueChangeDialog)sender;
+      bool flag1 = false, flag2 = false;
+      var node = dialog.Content;
+
+      if (node is VariableTreeNode) {
+        var variable = (VariableTreeNode)node;
+        var weight = double.Parse(dialog.newValueTextBox.Text);
+        var name = (string)dialog.variableNamesCombo.SelectedItem;
+        if (!variable.Weight.Equals(weight)) {
+          flag1 = true;
+          originalValues[variable] = variable.Weight;
+          variable.Weight = weight;
+        }
+        if (!variable.VariableName.Equals(name)) {
+          flag2 = true;
+          originalVariableNames[variable] = variable.VariableName;
+          variable.VariableName = name;
+        }
+      } else if (node is ConstantTreeNode) {
+        var constant = (ConstantTreeNode)node;
+        var value = double.Parse(dialog.newValueTextBox.Text);
+        if (!constant.Value.Equals(value)) {
+          flag1 = true;
+          originalValues[constant] = constant.Value;
+          constant.Value = value;
+        }
+      }
+      if (flag1 || flag2) {
+        UpdateView();
       }
     }
@@ -168,7 +201,16 @@
       double min = impacts.Min();
       foreach (ISymbolicExpressionTreeNode treeNode in Content.Model.SymbolicExpressionTree.IterateNodesPostfix()) {
+        VisualSymbolicExpressionTreeNode visualTree = treeChart.GetVisualSymbolicExpressionTreeNode(treeNode);
+        bool flag1 = replacementNodes.ContainsKey(treeNode);
+        bool flag2 = originalValues.ContainsKey(treeNode);
+        bool flag3 = treeNode is ConstantTreeNode;
+
+        if (flag2) // constant or variable node was changed
+          visualTree.ToolTip += Environment.NewLine + "Original value: " + originalValues[treeNode];
+        else if (flag1 && flag3) // symbol node was folded to a constant
+          visualTree.ToolTip += Environment.NewLine + "Original node: " + replacementNodes[treeNode];
+
         if (!(treeNode is ConstantTreeNode) && nodeImpacts.ContainsKey(treeNode)) {
           double impact = nodeImpacts[treeNode];
-          VisualSymbolicExpressionTreeNode visualTree = treeChart.GetVisualSymbolicExpressionTreeNode(treeNode);
 
           // impact = 0 if no change
@@ -197,10 +239,10 @@
     private void PaintCollapsedNodes() {
       foreach (ISymbolicExpressionTreeNode treeNode in Content.Model.SymbolicExpressionTree.IterateNodesPostfix()) {
-        if (treeNode is ConstantTreeNode && replacementNodes.ContainsKey(treeNode))
-          this.treeChart.GetVisualSymbolicExpressionTreeNode(treeNode).LineColor = Color.DarkOrange;
-        else {
-          VisualSymbolicExpressionTreeNode visNode = treeChart.GetVisualSymbolicExpressionTreeNode(treeNode);
-          if (visNode != null)
-            visNode.LineColor = Color.Black;
+        bool flag1 = replacementNodes.ContainsKey(treeNode);
+        bool flag2 = originalValues.ContainsKey(treeNode);
+        if (flag1 && treeNode is ConstantTreeNode) {
+          this.treeChart.GetVisualSymbolicExpressionTreeNode(treeNode).LineColor = flag2 ? Color.DarkViolet : Color.DarkOrange;
+        } else if (flag2) {
+          this.treeChart.GetVisualSymbolicExpressionTreeNode(treeNode).LineColor = Color.DodgerBlue;
         }
       }
@@ -208,5 +250,5 @@
 
     private void btnSimplify_Click(object sender, EventArgs e) {
-      SymbolicDataAnalysisExpressionTreeSimplifier simplifier = new SymbolicDataAnalysisExpressionTreeSimplifier();
+      var simplifier = new SymbolicDataAnalysisExpressionTreeSimplifier();
       var simplifiedExpressionTree = simplifier.Simplify(Content.Model.SymbolicExpressionTree);
       UpdateModel(simplifiedExpressionTree);
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/InteractiveSymbolicExpressionTreeChart.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/InteractiveSymbolicExpressionTreeChart.Designer.cs	(revision 8946)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/InteractiveSymbolicExpressionTreeChart.Designer.cs	(revision 8946)
@@ -0,0 +1,216 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Windows.Forms;
+
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Views {
+  partial class InteractiveSymbolicExpressionTreeChart {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.DoubleBuffered = true;
+      this.insertNodeToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
+      this.changeValueToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
+      this.copyToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
+      this.copyNodeToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
+      this.copySubtreeToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
+      this.cutToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
+      this.cutNodeToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
+      this.cutSubtreeToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
+      this.deleteToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
+      this.deleteNodeToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
+      this.deleteSubtreeToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
+      this.pasteToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
+      this.treeStatusLabel = new System.Windows.Forms.Label();
+      this.treeStatusValue = new System.Windows.Forms.Label();
+      this.SuspendLayout();
+      // 
+      // insertNodeToolStripMenuItem
+      // 
+      this.insertNodeToolStripMenuItem.Name = "insertNodeToolStripMenuItem";
+      this.insertNodeToolStripMenuItem.Size = new System.Drawing.Size(152, 22);
+      this.insertNodeToolStripMenuItem.Text = "Insert Node";
+      this.insertNodeToolStripMenuItem.Click += new System.EventHandler(this.insertNodeToolStripMenuItem_Click);
+      // 
+      // changeValueToolStripMenuItem
+      // 
+      this.changeValueToolStripMenuItem.Name = "changeValueToolStripMenuItem";
+      this.changeValueToolStripMenuItem.Size = new System.Drawing.Size(152, 22);
+      this.changeValueToolStripMenuItem.Text = "Change Value";
+      this.changeValueToolStripMenuItem.Click += new System.EventHandler(this.changeValueToolStripMenuItem_Click);
+      // 
+      // copyToolStripMenuItem
+      // 
+      this.copyToolStripMenuItem.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
+            this.copyNodeToolStripMenuItem,
+            this.copySubtreeToolStripMenuItem});
+      this.copyToolStripMenuItem.Name = "copyToolStripMenuItem";
+      this.copyToolStripMenuItem.Size = new System.Drawing.Size(152, 22);
+      this.copyToolStripMenuItem.Text = "Copy";
+      // 
+      // copyNodeToolStripMenuItem
+      // 
+      this.copyNodeToolStripMenuItem.Name = "copyNodeToolStripMenuItem";
+      this.copyNodeToolStripMenuItem.Size = new System.Drawing.Size(114, 22);
+      this.copyNodeToolStripMenuItem.Text = "Node";
+      this.copyNodeToolStripMenuItem.Click += new System.EventHandler(this.copyNodeToolStripMenuItem_Click);
+      // 
+      // copySubtreeToolStripMenuItem
+      // 
+      this.copySubtreeToolStripMenuItem.Name = "copySubtreeToolStripMenuItem";
+      this.copySubtreeToolStripMenuItem.Size = new System.Drawing.Size(114, 22);
+      this.copySubtreeToolStripMenuItem.Text = "Subtree";
+      this.copySubtreeToolStripMenuItem.Click += new System.EventHandler(this.copySubtreeToolStripMenuItem_Click);
+      // 
+      // cutToolStripMenuItem
+      // 
+      this.cutToolStripMenuItem.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
+            this.cutNodeToolStripMenuItem,
+            this.cutSubtreeToolStripMenuItem});
+      this.cutToolStripMenuItem.Name = "cutToolStripMenuItem";
+      this.cutToolStripMenuItem.Size = new System.Drawing.Size(152, 22);
+      this.cutToolStripMenuItem.Text = "Cut";
+      // 
+      // cutNodeToolStripMenuItem
+      // 
+      this.cutNodeToolStripMenuItem.Name = "cutNodeToolStripMenuItem";
+      this.cutNodeToolStripMenuItem.Size = new System.Drawing.Size(114, 22);
+      this.cutNodeToolStripMenuItem.Text = "Node";
+      this.cutNodeToolStripMenuItem.Click += new System.EventHandler(this.cutNodeToolStripMenuItem_Click);
+      // 
+      // cutSubtreeToolStripMenuItem
+      // 
+      this.cutSubtreeToolStripMenuItem.Name = "cutSubtreeToolStripMenuItem";
+      this.cutSubtreeToolStripMenuItem.Size = new System.Drawing.Size(114, 22);
+      this.cutSubtreeToolStripMenuItem.Text = "Subtree";
+      this.cutSubtreeToolStripMenuItem.Click += new System.EventHandler(this.cutSubtreeToolStripMenuItem_Click);
+      // 
+      // deleteToolStripMenuItem
+      // 
+      this.deleteToolStripMenuItem.DropDownItems.AddRange(new System.Windows.Forms.ToolStripItem[] {
+            this.deleteNodeToolStripMenuItem,
+            this.deleteSubtreeToolStripMenuItem});
+      this.deleteToolStripMenuItem.Name = "deleteToolStripMenuItem";
+      this.deleteToolStripMenuItem.Size = new System.Drawing.Size(152, 22);
+      this.deleteToolStripMenuItem.Text = "Delete";
+      // 
+      // deleteNodeToolStripMenuItem
+      // 
+      this.deleteNodeToolStripMenuItem.Name = "deleteNodeToolStripMenuItem";
+      this.deleteNodeToolStripMenuItem.Size = new System.Drawing.Size(114, 22);
+      this.deleteNodeToolStripMenuItem.Text = "Node";
+      this.deleteNodeToolStripMenuItem.Click += new System.EventHandler(this.deleteNodeToolStripMenuItem_Click);
+      // 
+      // deleteSubtreeToolStripMenuItem
+      // 
+      this.deleteSubtreeToolStripMenuItem.Name = "deleteSubtreeToolStripMenuItem";
+      this.deleteSubtreeToolStripMenuItem.Size = new System.Drawing.Size(114, 22);
+      this.deleteSubtreeToolStripMenuItem.Text = "Subtree";
+      this.deleteSubtreeToolStripMenuItem.Click += new System.EventHandler(this.deleteSubtreeToolStripMenuItem_Click);
+      // 
+      // pasteToolStripMenuItem
+      // 
+      this.pasteToolStripMenuItem.Name = "pasteToolStripMenuItem";
+      this.pasteToolStripMenuItem.Size = new System.Drawing.Size(152, 22);
+      this.pasteToolStripMenuItem.Text = "Paste";
+      this.pasteToolStripMenuItem.Click += new System.EventHandler(this.pasteToolStripMenuItem_Clicked);
+      //
+      // contextMenuStrip
+      //
+      this.contextMenuStrip.Opened += this.contextMenuStrip_Opened;
+      this.contextMenuStrip.Items.AddRange(new ToolStripItem[] { insertNodeToolStripMenuItem,
+                                                                 changeValueToolStripMenuItem, 
+                                                                 copyToolStripMenuItem, 
+                                                                 cutToolStripMenuItem, 
+                                                                 deleteToolStripMenuItem, 
+                                                                 pasteToolStripMenuItem });
+      // 
+      // treeStatusLabel
+      // 
+      this.treeStatusLabel.AutoSize = true;
+      this.treeStatusLabel.BackColor = System.Drawing.Color.Transparent;
+      this.treeStatusLabel.Location = new System.Drawing.Point(3, 0);
+      this.treeStatusLabel.Name = "treeStatusLabel";
+      this.treeStatusLabel.Size = new System.Drawing.Size(68, 13);
+      this.treeStatusLabel.TabIndex = 0;
+      this.treeStatusLabel.Text = "Tree Status: ";
+      // 
+      // treeStatusValue
+      // 
+      this.treeStatusValue.AutoSize = true;
+      this.treeStatusValue.BackColor = System.Drawing.Color.Transparent;
+      this.treeStatusValue.ForeColor = System.Drawing.Color.Green;
+      this.treeStatusValue.Location = new System.Drawing.Point(77, 0);
+      this.treeStatusValue.Name = "treeStatusValue";
+      this.treeStatusValue.Size = new System.Drawing.Size(30, 13);
+      this.treeStatusValue.TabIndex = 1;
+      this.treeStatusValue.Text = "Valid";
+      // 
+      // InteractiveSymbolicExpressionTreeChart
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.treeStatusLabel);
+      this.Controls.Add(this.treeStatusValue);
+      this.Name = "InteractiveSymbolicExpressionTreeChart";
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    private ToolStripMenuItem insertNodeToolStripMenuItem;
+    private ToolStripMenuItem changeValueToolStripMenuItem;
+    private ToolStripMenuItem copyToolStripMenuItem;
+    private ToolStripMenuItem copyNodeToolStripMenuItem;
+    private ToolStripMenuItem copySubtreeToolStripMenuItem;
+    private ToolStripMenuItem cutToolStripMenuItem;
+    private ToolStripMenuItem cutNodeToolStripMenuItem;
+    private ToolStripMenuItem cutSubtreeToolStripMenuItem;
+    private ToolStripMenuItem pasteToolStripMenuItem;
+    private ToolStripMenuItem deleteToolStripMenuItem;
+    private ToolStripMenuItem deleteNodeToolStripMenuItem;
+    private ToolStripMenuItem deleteSubtreeToolStripMenuItem;
+
+    #endregion
+    private Label treeStatusLabel;
+    private Label treeStatusValue;
+  }
+}
